#define ASM 1
#include "mboot.h"

#ifdef GRAPHIC_MODE
#	define GRAPHIC_FLAG		      0x00000004
#	define VID_W 			      1280
#	define VID_H			      1024
#	define VID_B			      8
#else
#	define GRAPHIC_FLAG		      0x00000000
#endif

#ifdef __ELF__
#	define MULTIBOOT_HEADER_FLAGS         (0x00000003|GRAPHIC_FLAG)
#else
# 	define MULTIBOOT_HEADER_FLAGS         (0x00010003|GRAPHIC_FLAG)
#endif

.global start,_start
.text
start:				// entry point
_start:
     jmp     multiboot_entry	// scavalchiamo la struttra richiesta
     				// dal bootstrap loader, che deve
				// trovarsi verso l'inizio del file

     .align  4
     // le seguenti informazioni sono richieste dal bootstrap loader
multiboot_header:
     .long   MULTIBOOT_HEADER_MAGIC 				// valore magico
     .long   MULTIBOOT_HEADER_FLAGS   				// flag
     .long   -(MULTIBOOT_HEADER_MAGIC + MULTIBOOT_HEADER_FLAGS) // checksum
     .long   multiboot_header
     .long   _start
     .long   _edata
     .long   _end
     .long   multiboot_entry
#ifdef GRAPHIC_MODE
     .long 0
     .long VID_W
     .long VID_H
     .long VID_B
#endif

multiboot_entry:
#ifdef GRAPHIC_MODE
	cmpl $MULTIBOOT_BOOTLOADER_MAGIC, %eax
	jne svga_done
	movl (%ebx), %eax
	testl $0x1000, %eax
	jz svga_done
	movl 88(%ebx), %eax
	movl %eax, framebuffer
svga_done:
#endif
	call init_all
#	call ___main
        call main
	call stop_all
	lidt triple_fault_idt
	int $1

triple_fault_idt:
	.word 0
	.long 0
        

.bss
stack:
#        .space 65536, 0
	.space 1024, 0
estack:
#ifdef GRAPHIC_MODE
	.global framebuffer
framebuffer:
	.long	0
#endif
